package com.zt.plat.module.base.service.base;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.base.controller.admin.base.vo.WarehousePageReqVO;
import com.zt.plat.module.base.controller.admin.base.vo.WarehouseRespVO;
import com.zt.plat.module.base.controller.admin.base.vo.WarehouseSaveReqVO;
import com.zt.plat.module.base.dal.dataobject.base.WarehouseDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 仓库 Service 接口
 *
 * @author 后台管理
 */
public interface WarehouseService {

    /**
     * 创建仓库
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    WarehouseRespVO createWarehouse(@Valid WarehouseSaveReqVO createReqVO);

    /**
     * 更新仓库
     *
     * @param updateReqVO 更新信息
     */
    void updateWarehouse(@Valid WarehouseSaveReqVO updateReqVO);

    /**
     * 删除仓库
     *
     * @param id 编号
     */
    void deleteWarehouse(Long id);

    /**
    * 批量删除仓库
    *
    * @param ids 编号
    */
    void deleteWarehouseListByIds(List<Long> ids);

    /**
     * 获得仓库
     *
     * @param id 编号
     * @return 仓库
     */
    WarehouseDO getWarehouse(Long id);

    /**
     * 获得仓库分页
     *
     * @param pageReqVO 分页查询
     * @return 仓库分页
     */
    PageResult<WarehouseDO> getWarehousePage(WarehousePageReqVO pageReqVO);

    void enableWarehouseList(List<WarehouseRespVO> saveReqVOS);
}